#include <stdio.h>
#include <stdlib.h>
#include <string.h>


typedef void (*funcP)(void);


int test1(char *msg);
int test2(char *msg);
void _jmp(void);
void _dump(char *msg);
void _hook_init(char *ptr, char *buf, int n);
void _hook(char *ptr, char *hook, char *bak, int n);


unsigned int t1_ptr = (unsigned int)test2;
unsigned int t2_ptr[] = { (unsigned int)test2 };
char buf1[10];
char buf2[10];


int test1(char *msg)
{
	printf("test1! '%s'\n", msg);
	return -1;
}

int test2(char *msg)
{
	printf("test2! '%s'\n", msg);
	return -2;
}

void _dump(char *msg)
{
	int i;

	puts(msg);
	printf("T1_p: %p T2_p: %p\n", test1, test2);
	printf("T2_ptr: %p T2_ptr[0]: %p\n\n", t2_ptr, (int *)*t2_ptr);
	for (i = 0; i < 16; i++) {
		printf("T1 %p %08X  T2 %p %08X  JMP %p %08X\n",
			test1 + i * sizeof(int), ((int *)test1)[i],
			test2 + i * sizeof(int), ((int *)test2)[i],
			_jmp + i * sizeof(int), ((int *)_jmp)[i]);
	}
}

int main(void)
{
	printf("** init\n");
	
	test1("aa");
	test2("bb");

	_hook_init((char *)_jmp, buf1, sizeof(buf1));

	printf("** start\n");

	printf("** %d\n", test1("cc"));
	_hook((char *)test1, buf1, buf2, sizeof(buf1));
	printf("** %d\n", test1("dd"));
	_hook((char *)test1, buf2, buf1, sizeof(buf1));
	printf("** %d\n", test1("ee"));

	printf("** end\n");

	return 0;
}

void _hook_init(char *ptr, char *buf, int n)
{
	//memcpy(buf, ptr + 3, n);
	buf[0] = 0xff;
	buf[1] = 0x25;
	*(int *)(buf + 2) = (int)&t1_ptr;
}

void _hook(char *ptr, char *hook, char *bak, int n)
{
	//_dump("[1]");
	memcpy(bak, ptr, n);
	memcpy(ptr, hook, n);
	//_dump("[2]");
}

void _jmp(void)
{
	__asm__ __volatile__ ("jmp *t2_ptr;");
	__asm__ __volatile__ ("nop; nop; nop; nop;");
}
